<img src="https://user-images.githubusercontent.com/2319867/235838660-a82bfdce-aa55-461d-b418-19bd5185b6af.png" width="50%" height="50%">

Provides an idiomatic Dart projection of the Windows Runtime (WinRT) APIs
from the `Windows.Networking` namespace using Dart FFI.
Part of the [Dart | Windows] suite of Windows packages.

[![pub package](https://img.shields.io/pub/v/windows_networking.svg)](https://pub.dev/packages/windows_networking)
[![package publisher](https://img.shields.io/pub/publisher/windows_networking.svg)](https://pub.dev/publishers/win32.pub)
[![Language](https://img.shields.io/badge/language-Dart-blue.svg)](https://dart.dev)
[![License](https://img.shields.io/github/license/dart-windows/dartwinrt?color=blue)](https://opensource.org/licenses/BSD-3-Clause)

## Documentation 📝

For official documentation, please visit https://dartwinrt.dev.

## Examples

The package includes a few examples in the
[example/](/packages/windows_networking/example) subdirectory, which
demonstrate calling various Windows Runtime APIs from the `Windows.Networking`
namespace.

## Features and bugs

The WinRT APIs that are projected by this package are limited, but additional
APIs will be added based on user demand, especially if it helps facilitate the
development of new Dart packages for Windows.

If you encounter any issues or have any feature requests, please submit them
through the [issue tracker].

## Acknowledgements

The summary WinRT API documentation comments are [licensed by Microsoft][] under
the [Creative Commons Attribution 4.0 International Public License][license].

[Dart | Windows]: https://github.com/dart-windows
[issue tracker]: https://github.com/dart-windows/dartwinrt/issues
[licensed by Microsoft]: https://github.com/MicrosoftDocs/winrt-api/#legal-notices
[license]: https://github.com/MicrosoftDocs/winrt-api/blob/89e9254fd8b53a648937dbb4324d7f7d6f8d1314/LICENSE
